//
//		A fine resolution timer.  Y. Okamoto,  2010.03
//
#ifndef FINETIMER_CK
#define FINETIMER_CK

#include <Windows.h>

namespace mytimer {

	class MyTimer {
		public:

			LARGE_INTEGER L_I;
			bool ck;
			double f, m_d_f;
			double c; 

			MyTimer(): ck(false) {
				if ( QueryPerformanceFrequency( &L_I ) ) {
					ck = true;
					c = pow(2.0, 32.0);
					f = L_I.LowPart + c * L_I.HighPart;		//	counts/sec
					m_d_f = 1000000.0 / f;					//	microseconds/count
				}
			}

			//    In microsecond unit
			double time(){
				if (ck) {
					QueryPerformanceCounter( &L_I );
					double v = L_I.HighPart * c + L_I.LowPart;
					return v * m_d_f;
				} else {
					return 0.0;
				}
			}
			
			//   In millisecond unit
			int timems(){
				return int(time() * 0.001);
			}

	};

}

#endif
